"""Main input file for running a hoomd-blue opv_cg simulation."""
from cme_utils.job_control import manager
from random import randint
import os
import sys
home_dir = os.environ['HOME']
user = os.environ['USER']
run_dir = "/{}/runs/".format(user)
sim_db_filename = 'sim_db.sqlite3'
#################################################

email = ""
username = ''
queue_name = '' #kestrel

project = "P3HT"

desired_hours = 20

submit_job = True

run_type = 'new'

model_dir = "mlibs/models/P3HT_Fullerene/"

model_file = model_dir+"model.xml"
model_name = "default"

bb_file = {}
bb_num = {}

n_mol = 1
bb_file['50mer']=model_dir+'50mer.xml'
bb_file['p3ht']=model_dir+'p3ht.xml'

bb_num['50mer'] = 0
bb_num['p3ht'] = 1

parent = 0 # 0,None start new jobs, 'last' depends on the last job, and a number>0 will depend on that job

if run_type=='new':
    parent = 0
parent_file = "restart.xml"

e_factor = 0.8
P = 1.0 #float(sys.argv[2])
T = 4.0
mixT = 8.0
dt = 0.001
P = 1.0
tauP= 1.
tauT= 1.
phi= 1.38
tmax = 5.0e7
log_write_time = 1e5
dcd_write_time = 1e6
mix_time = 1e6
shrink_time = 2e7
shrinkT = 8.
ensemble="NVT"
seed = randint(0,2**32)
estimate_tps = 200
tabulated_dihedral = True
shrinking = False

custom_prefix = '{}-dt{}-phi{}-P{}-e_factor-{}-n_mol{}'.format(project,dt,phi,P,e_factor,n_mol)  
name_pattern="{0}-T{1}"
run_name = name_pattern.format(custom_prefix,T)

######################
members = [ i for i in dir() if (not i.startswith('__')) and (not callable(i)) and (i not in ['opv','manager','sys','os'] ) ]
params ={} 
for m in members:
    params[m] = locals()[m]
manager.HoomdRun(**params) #magic happens in here: run is added, paths are set, etc.
